c  applies offsets, rate changes, and exponential to GPS data
c
      dimension yr(2009901), fjul(2009901), data(2009901),
     &   er(2009901),time(2009901)
      double precision time,toff,ffjul,ffjul2, toff2,fjul
      character*16 ifile, ofile
      character*1 func_type
      max=2009901
      print*,' Program performs adjustments to GPS data'
      print*,'   works with offset, rate changes and exponentials'
      print*,'  specify function type'
      print*,'   followed by specifications for function'
      print*,'  o = offset'
      print*,'     year, julian day, ammount of offset'
      print*,'  R = rate'
      print*,'      rate in unit/yr'
      print*,'  r = rate change'
      print*,'     year, julian day, rate change unit/yr'
      print*,'  e = exponential (1 - e (-t/tau))'
      print*,'     year, julian day, tau (years), amplitude'
      print*,'  m = logrithm  log10 (1 + t/tau) '
      print*,'  s = cosine/sine '
      print*,'     reference year, julian day, period (days), ',
     &        ' cosine amp, sine amp'
      print*,' Input GPS data file to apply offsets (cmbb.u)'
      read(5,100)ifile
100   format(a16)
      open(1,file=ifile)
      print*,' Input name of file with offset corrections (Ocmbb.u)'
      read(5,100) ofile
      print*,'  file name is  ',ofile
      open(2,file=ofile)
      n=1
1     continue
      if (n .gt. max ) then
         print*,' Number of data',n,' exceeds dimension',max
         stop
      end if
      read(1,*,end=10)yr(n),fjul(n),data(n),er(n)
      iyr=int(yr(n))
      ijul=int(fjul(n))
      call jul2day(iyr,ijul,iday)
      time(n)=float(iday)+fjul(n)-float(ijul)
      n=n+1
      go to 1
10    continue
      n=n-1
      if (n .gt. max) then
        print*,' number of data exceeds dimensions', n,max
        stop
      end if
      print*,' number of data',n
      noff=0
      nexp=0
      nrate=0
      nlog=0
      nsea=0
      nrates=0
20    continue
      read(2,*,end=50) func_type
        if (func_type .eq. 'o') then
c    deal with offset
          read(2,*) year, ffjul, off
          call jul2day(int(year),int(ffjul),iday)
          toff=float(iday)+ffjul-float(int(ffjul))
          do 21 i=1,n
          if (time(i) .ge. toff) data(i)=data(i)+off
21        continue
          noff=noff+1
        end if
        if (func_type .eq. 'r') then
c  deal with rate change
          read(2,*) year, ffjul, year2,ffjul2, rate
          call jul2day(int(year),int(ffjul),iday)
          toff=float(iday)+ffjul-float(int(ffjul))
          call jul2day(int(year2),int(ffjul2),iday)
          toff2=float(iday)+ffjul2-float(int(ffjul2))
          do 22 i=1,n
          if ((time(i) .ge. toff) .and. 
     &     (time(i) .lt. toff2))  data(i)=data(i)
     &      +rate*(time(i)-toff)/365.25
          if (time(i) .ge. toff2) data(i)=data(i)
     &      + rate*(toff2-toff)/365.25
22        continue

          nrate=nrate+1
        end if
        if (func_type .eq. 'e') then
c  deal with exponentials
          read(2,*) year, ffjul, tau, amp
          call jul2day(int(year),int(ffjul),iday)
          toff=float(iday)+ffjul-float(int(ffjul))
          do 23 i=1,n
          if (time(i) .ge. toff) data(i)=data(i)
     &     +amp*(1.0 - exp(-(time(i)-toff)/(tau*365.25)) )
23        continue
          nexp=nexp+1
        end if
        if (func_type .eq. 'm') then
c  deal with logrithm
          read(2,*) year, ffjul, tau, amp
          call jul2day(int(year),int(ffjul),iday)
          toff=float(iday)+ffjul-float(int(ffjul))
          do 24 i=1,n
          if (time(i) .ge. toff) data(i)=data(i)
     &     +amp*dlog10(1.0 + (time(i)-toff)/(tau*365.25))
24        continue
          nlog=nlog+1
        end if
        if (func_type .eq. 's') then
        read(2,*)year,ffjul,per, camp,samp
          call jul2day(int(year),int(ffjul),iday)
          tref=float(iday)+ffjul-float(int(ffjul))
          freq=2.0*3.1415926/per
          do 25 i=1,n
          data(i)=data(i)+camp*cos(freq*(time(i)-tref))
     &      + samp*sin(freq*(time(i)-tref))
25        continue
         nsea=nsea+1
        end if 
        if (func_type .eq. 'R' ) then
c  deal with removing the rate
          read(2,*)rate
          do 26 i=1,n
c          data(i)=data(i)+rate*(time(i)-float(izz))/365.25
          data(i)=data(i)+rate*(time(i)-time(1))/365.25
26        continue
          nrates=nrates+1
       end if
      go to 20
50    continue
      rewind(1)
      do 60 i=1,n
60    write(1,*)yr(i),fjul(i),data(i),er(i)
      print*,' number of sinusoids fixed', nsea
      print*,' number of offset fixed', noff
      print*,' number of ratechanges fixed', nrate
      print*,' Number of exponentials fixed', nexp
      print*,' Number of secular rates fixed', nrates
      print*,' Number of logrithm/omori fixed', nlog
      print*,' Adjusted data in file ', ifile
      close(1)
      close(2)
      stop
      end
